/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package testsuite;

import java.awt.Point;
import java.util.HashMap;

/**
 *
 * @author Markus Ullrich
 */
public class RucksackDynamisch {

    private HashMap<Integer, Point> gegenstaende;
    private HashMap<Integer,HashMap<Integer,Integer>> memoliste;
    private int rekursiveAufrufe;
    private javax.swing.JLabel testLabel;
    private javax.swing.JTextField testField;
    private javax.swing.JFrame frame;

    public RucksackDynamisch(HashMap<Integer,Point> gegenstaende)
    {
        this.gegenstaende = gegenstaende;
        memoliste = new HashMap<Integer,HashMap<Integer,Integer>>();
    }
    //Stelle für rekursiven Aufruf?
    public int[] iterativ(int kapazitaet)
    {
        int[] zeileAlt = new int[kapazitaet+1];
        int[] zeileNeu = new int[kapazitaet+1];
        String[] zeileAltG = new String[kapazitaet+1];
        String[] zeileNeuG = new String[kapazitaet+1];
        for(int z = 1; z <= gegenstaende.size();z++)
        {
            System.arraycopy(zeileNeu, 0, zeileAlt, 0, zeileNeu.length);
            System.arraycopy(zeileNeuG, 0, zeileAltG, 0, zeileNeuG.length);
            //zeileAlt = zeileNeu.clone();
            int gewicht = (int)gegenstaende.get(z).getX();
            for(int s = 0; s <= kapazitaet; s++)
            {
                if(s >= gewicht)
                {
                    int temp = zeileAlt[s-gewicht] + (int)gegenstaende.get(z).getY();
                    if(temp>zeileAlt[s])
                    {
                        zeileNeu[s] = temp;
                        if(zeileAltG[s-gewicht] == null)
                        {
                            zeileNeuG[s] = z+"";
                        }                        
                        else
                        {
                            
                            zeileNeuG[s] = zeileAltG[s-gewicht] + ";" + z;
                        }
                    }
                }
            }
        }
       if(zeileNeuG[kapazitaet] != null)
       {
           String[] g = zeileNeuG[kapazitaet].split(";");
           int[] back = new int[g.length];
           for(int i=0; i<g.length; i++)
           {
               back[i] = Integer.parseInt(g[i]);
           }
           return back;
       }
        return null;
    }
    
    private void tabellenAnsicht()
    {
        frame = new javax.swing.JFrame("Test");
        testLabel = new javax.swing.JLabel("Kapazität einegeben:");
        javax.swing.JButton testButton = new javax.swing.JButton("Ausführen");
        testButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			try
            {
                int kapazitaet = Integer.parseInt(testField.getText());
                if(kapazitaet<1||kapazitaet>200)
                {
                    throw new NumberFormatException();
                }
            }
            catch(Exception ex)
            {
                javax.swing.JOptionPane.showMessageDialog(frame, "Bitte nur Zahlen zwischen 1 und 200 eingeben!", "Falsches EIngabeformat!", javax.swing.JOptionPane.ERROR_MESSAGE);
            }
		}});
        frame.setLayout(new java.awt.GridLayout(1,3));
        frame.add(testLabel);
        frame.add(testButton);
        frame.pack();
        frame.setVisible(true);
    }
    public int gesamtwertRekursiv(int kapazitaet)
    {
        rekursiveAufrufe = 0;
        return gesamtWert(gegenstaende.size(),kapazitaet);
    }
    public int gesamtwertRekursivMemo(int kapazitaet)
    {
        rekursiveAufrufe = 0;
        return gesamtWert1(gegenstaende.size(),kapazitaet);
    }
    //Stelle für rekursiven Aufruf?
    private int gesamtWert(int pos,int kapazitaet)
    {
        rekursiveAufrufe++;
        if(pos==0)
        {
            return 0;
        }
        else
        {
            if(gegenstaende.get(pos).getX()>kapazitaet)
            {
                return gesamtWert(pos-1,kapazitaet);
            }
            else
            {
                int var1 = gesamtWert(pos-1,kapazitaet);
                int var2 = gesamtWert(pos-1,kapazitaet-(int)gegenstaende.get(pos).getX()) + (int)gegenstaende.get(pos).getY();
                if(var1>var2)
                {
                    return var1;
                }
                else
                {
                    return var2;
                }
                //entweder aktueller Wert + letzten Wert, oder ohne diesen
            }
        }
    }
    private int gesamtWert1(int pos,int kapazitaet)
    {
        rekursiveAufrufe++;
        if(pos==0)
        {
            return 0;
        }
        else
        {
            if(gegenstaende.get(pos).getX()>kapazitaet)
            {
                return gesamtWertMemo(pos-1,kapazitaet);
            }
            else
            {
                int var1 = gesamtWertMemo(pos-1,kapazitaet);
                int var2 = gesamtWertMemo(pos-1,kapazitaet-(int)gegenstaende.get(pos).getX()) + (int)gegenstaende.get(pos).getY();
                if(var1>var2)
                {
                    return var1;
                }
                else
                {
                    return var2;
                }
            }
        }
    }
    private int gesamtWertMemo(int pos, int kapazitaet)
    {
        if(memoliste.containsKey(pos))
        {
            if(memoliste.get(pos).containsKey(kapazitaet))
            {
                return memoliste.get(pos).get(kapazitaet);
            }
            else
            {
                int resultat = gesamtWert1(pos,kapazitaet);
                memoliste.get(pos).put(kapazitaet, resultat);
                return resultat;
            }
        }
        else
        {
            int resultat = gesamtWert1(pos,kapazitaet);
            HashMap<Integer,Integer> temp = new HashMap<Integer,Integer>();
            temp.put(kapazitaet, resultat);
            memoliste.put(pos, temp);
            return resultat;
        }
    }
    public int getRekursiveAufrufe()
    {
        return rekursiveAufrufe;
    }
    public int getLengthMemoListe()
    {
        int size = 0;
        for(int i= 0 ; i < memoliste.size();i++)
        {
            size+=memoliste.get(i).size();
        }
        return size;
    }

}
