/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package testsuite;

import java.math.BigInteger;
import java.util.HashMap;

/**
 *
 * @author Markus Ullrich
 */
public class FibMemo {

    private BigInteger actualValue;
    private HashMap<Integer, BigInteger> values;

    public FibMemo()
    {
        values = new HashMap<Integer,BigInteger>(); 
    }

    public BigInteger optimizedFib(int count)
    {
        BigInteger back = BigInteger.ONE;
        for(int i = 0; i < count; i = i+1000)
        {
            back = calculateValue(i);
        }
        back = calculateValue(count);
        return back;
        
    }
    
    public BigInteger calculateValue(int count) throws StackOverflowError
    {
        if(count<2)
        {
            return BigInteger.ONE;
        }
        else
        {
            if(values.containsKey(count))
            {
                return values.get(count);
            }
            else
            {
                BigInteger fib1 = calculateValue(count-1);
                
                
                BigInteger fib2 = calculateValue(count-2);values.put(count-1, fib1);
                values.put(count-2, fib2);
                values.remove(count-3);
                return fib1.add(fib2);
            }
        }
    }
    public BigInteger getBiggestBigInteger()
    {
        System.gc();
        values.clear();
        System.out.println(calculateValue(5));
        System.out.println(calculateValue(30));
        System.out.println(calculateValue(500));
        System.out.println(calculateValue(5000));
        System.out.println(calculateValue(8099));
        BigInteger biggest = calculateValue(8099);
        values.clear();
        BigInteger toAdd = new BigInteger(biggest.toString());
        while(!toAdd.equals(BigInteger.ZERO))
        {
            toAdd = toAdd.subtract(BigInteger.ONE);
            boolean maxReached = false;
            while(!maxReached)
            {
                try
                {
                    
                    biggest = biggest.multiply(toAdd);
                    System.out.println(biggest);
                }
                catch(Exception ex)
                {
                    maxReached = true;
                }
            }
            System.out.println(toAdd + " : " + biggest);
        }
        return biggest;
    }

}
