/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package testsuite;

import java.awt.Point;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Markus Ullrich
 */
public class MatrixChainMultiplication {

    private List<int[][]> matrizen;
    int allOperations;
    private List<Point> optimaleKlammerungen;
    
    public MatrixChainMultiplication(List<int[][]> matrizen)
    {
        this.matrizen = matrizen;
        allOperations = 0;
        optimaleKlammerungen = null;
    }
    public MatrixChainMultiplication()
    {
        this.matrizen = null;
        allOperations = 0;
        optimaleKlammerungen = null;
    }
    public int[][] multAll()
    {
        allOperations = 0;
        int[][] back = null;
        Iterator<int[][]> iter = matrizen.iterator();
        back = iter.next();
        while(iter.hasNext())
        {
            back = matMult(back,iter.next());
        }
        System.out.println("" + allOperations);
        return back;
    }
    public List<Point> optimaleKlammerung()
    {
        optimaleKlammerungen = new LinkedList<Point>();
        
        return optimaleKlammerungen;
    }
    private int minMult(int i,int j)
    {
        if(i==j)
        {
            return 0;
        }
        else
        {
            int back = Integer.MAX_VALUE;
            for(int k = i ; k < j ; k++)
            {
                int temp = minMult(i,k) + minMult(k+1,j) + (matrizen.get(i).length * matrizen.get(j)[0].length * matrizen.get(k)[0].length);
                back = java.lang.Math.min(back, temp);
            }
            return back;
        }
    }

    public int minMult()
    {
        return minMult(0,matrizen.size()-1);
    }
    public int[][] matMult(int[][] mat1, int[][] mat2)
    {
        int ops = 0;
        int[][] back = new int[mat1.length][mat2[0].length];
        for(int i = 0;i < mat2[0].length ; i++)
        {
            for(int j = 0 ; j < mat1.length ; j++)
            {
                for(int x = 0 ; x < mat2.length ; x++)
                {
                    ops++;
                    back[j][i] += mat1[j][x] * mat2[x][i];
                }
            }
        }
        System.out.println("" + ops);
        allOperations += ops;
        return back;
    }
    public int[][] generateMatrix(int rows, int columns, int numbersize)
    {
        Random random = new Random();
        int[][] back = new int[rows][columns];
        for(int i = 0 ; i < rows ; i++)
        {
            for(int j = 0; j < columns ; j++)
            {
                back[i][j] = random.nextInt(numbersize);
            }
        }
        return back;
    }
    
}
